/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Account, Address, Codec, Decoder, EncodedAccount, Encoder, FetchAccountConfig, FetchAccountsConfig, MaybeAccount, MaybeEncodedAccount, Option, OptionOrNullable, ReadonlyUint8Array, fetchEncodedAccount, fetchEncodedAccounts } from '@solana/web3.js';
import { NullableAddress, NullableAddressArgs } from '../../hooked';
import { BidStateSeeds } from '../pdas';
import { Field, FieldArgs, Target, TargetArgs } from '../types';
export type BidState = {
    discriminator: ReadonlyUint8Array;
    version: number;
    bump: Array<number>;
    owner: Address;
    /** Randomly picked pubkey used in bid seeds. To avoid dangling bids can use assetId here. */
    bidId: Address;
    target: Target;
    targetId: Address;
    field: Option<Field>;
    fieldId: Option<Address>;
    quantity: number;
    filledQuantity: number;
    amount: bigint;
    currency: Option<Address>;
    expiry: bigint;
    privateTaker: Option<Address>;
    makerBroker: Option<Address>;
    margin: Option<Address>;
    updatedAt: bigint;
    cosigner: NullableAddress;
    /** owner is the rent payer when this is `None` */
    rentPayer: NullableAddress;
    reserved: Array<number>;
    reserved1: Array<number>;
    reserved2: ReadonlyUint8Array;
};
export type BidStateArgs = {
    version: number;
    bump: Array<number>;
    owner: Address;
    /** Randomly picked pubkey used in bid seeds. To avoid dangling bids can use assetId here. */
    bidId: Address;
    target: TargetArgs;
    targetId: Address;
    field: OptionOrNullable<FieldArgs>;
    fieldId: OptionOrNullable<Address>;
    quantity?: number;
    filledQuantity: number;
    amount: number | bigint;
    currency: OptionOrNullable<Address>;
    expiry: number | bigint;
    privateTaker: OptionOrNullable<Address>;
    makerBroker: OptionOrNullable<Address>;
    margin: OptionOrNullable<Address>;
    updatedAt: number | bigint;
    cosigner: NullableAddressArgs;
    /** owner is the rent payer when this is `None` */
    rentPayer: NullableAddressArgs;
    reserved: Array<number>;
    reserved1: Array<number>;
    reserved2: ReadonlyUint8Array;
};
export declare function getBidStateEncoder(): Encoder<BidStateArgs>;
export declare function getBidStateDecoder(): Decoder<BidState>;
export declare function getBidStateCodec(): Codec<BidStateArgs, BidState>;
export declare function decodeBidState<TAddress extends string = string>(encodedAccount: EncodedAccount<TAddress>): Account<BidState, TAddress>;
export declare function decodeBidState<TAddress extends string = string>(encodedAccount: MaybeEncodedAccount<TAddress>): MaybeAccount<BidState, TAddress>;
export declare function fetchBidState<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<Account<BidState, TAddress>>;
export declare function fetchMaybeBidState<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<MaybeAccount<BidState, TAddress>>;
export declare function fetchAllBidState(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<Account<BidState>[]>;
export declare function fetchAllMaybeBidState(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<MaybeAccount<BidState>[]>;
export declare function fetchBidStateFromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: BidStateSeeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<Account<BidState>>;
export declare function fetchMaybeBidStateFromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: BidStateSeeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<MaybeAccount<BidState>>;
//# sourceMappingURL=bidState.d.ts.map