/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, Option, OptionOrNullable, ReadonlyAccount, ReadonlySignerAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_MARKETPLACE_PROGRAM_ADDRESS } from '../programs';
import { Field, FieldArgs, Target, TargetArgs } from '../types';
export type BidInstruction<TProgram extends string = typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountMarketplaceProgram extends string | IAccountMeta<string> = 'TCMPhJdwDryooaGtiocG1u3xcYbRpiJzb283XfCZsDp', TAccountBidState extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountSharedEscrow extends string | IAccountMeta<string> = string, TAccountCosigner extends string | IAccountMeta<string> = string, TAccountRentPayer extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountMarketplaceProgram extends string ? ReadonlyAccount<TAccountMarketplaceProgram> : TAccountMarketplaceProgram,
    TAccountBidState extends string ? WritableAccount<TAccountBidState> : TAccountBidState,
    TAccountOwner extends string ? WritableSignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountSharedEscrow extends string ? WritableAccount<TAccountSharedEscrow> : TAccountSharedEscrow,
    TAccountCosigner extends string ? ReadonlySignerAccount<TAccountCosigner> & IAccountSignerMeta<TAccountCosigner> : TAccountCosigner,
    TAccountRentPayer extends string ? WritableSignerAccount<TAccountRentPayer> & IAccountSignerMeta<TAccountRentPayer> : TAccountRentPayer,
    ...TRemainingAccounts
]>;
export type BidInstructionData = {
    discriminator: ReadonlyUint8Array;
    bidId: Address;
    target: Target;
    targetId: Address;
    field: Option<Field>;
    fieldId: Option<Address>;
    amount: bigint;
    quantity: number;
    expireInSec: Option<bigint>;
    currency: Option<Address>;
    privateTaker: Option<Address>;
    makerBroker: Option<Address>;
};
export type BidInstructionDataArgs = {
    bidId: Address;
    target: TargetArgs;
    targetId: Address;
    field?: OptionOrNullable<FieldArgs>;
    fieldId?: OptionOrNullable<Address>;
    amount: number | bigint;
    quantity?: number;
    expireInSec?: OptionOrNullable<number | bigint>;
    currency?: OptionOrNullable<Address>;
    privateTaker?: OptionOrNullable<Address>;
    makerBroker?: OptionOrNullable<Address>;
};
export declare function getBidInstructionDataEncoder(): Encoder<BidInstructionDataArgs>;
export declare function getBidInstructionDataDecoder(): Decoder<BidInstructionData>;
export declare function getBidInstructionDataCodec(): Codec<BidInstructionDataArgs, BidInstructionData>;
export type BidAsyncInput<TAccountSystemProgram extends string = string, TAccountMarketplaceProgram extends string = string, TAccountBidState extends string = string, TAccountOwner extends string = string, TAccountSharedEscrow extends string = string, TAccountCosigner extends string = string, TAccountRentPayer extends string = string> = {
    systemProgram?: Address<TAccountSystemProgram>;
    marketplaceProgram?: Address<TAccountMarketplaceProgram>;
    bidState?: Address<TAccountBidState>;
    owner: TransactionSigner<TAccountOwner>;
    sharedEscrow?: Address<TAccountSharedEscrow>;
    cosigner?: TransactionSigner<TAccountCosigner>;
    rentPayer?: TransactionSigner<TAccountRentPayer>;
    bidId?: BidInstructionDataArgs['bidId'];
    target: BidInstructionDataArgs['target'];
    targetId: BidInstructionDataArgs['targetId'];
    field?: BidInstructionDataArgs['field'];
    fieldId?: BidInstructionDataArgs['fieldId'];
    amount: BidInstructionDataArgs['amount'];
    quantity?: BidInstructionDataArgs['quantity'];
    expireInSec?: BidInstructionDataArgs['expireInSec'];
    currency?: BidInstructionDataArgs['currency'];
    privateTaker?: BidInstructionDataArgs['privateTaker'];
    makerBroker?: BidInstructionDataArgs['makerBroker'];
};
export declare function getBidInstructionAsync<TAccountSystemProgram extends string, TAccountMarketplaceProgram extends string, TAccountBidState extends string, TAccountOwner extends string, TAccountSharedEscrow extends string, TAccountCosigner extends string, TAccountRentPayer extends string>(input: BidAsyncInput<TAccountSystemProgram, TAccountMarketplaceProgram, TAccountBidState, TAccountOwner, TAccountSharedEscrow, TAccountCosigner, TAccountRentPayer>): Promise<BidInstruction<typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountSystemProgram, TAccountMarketplaceProgram, TAccountBidState, TAccountOwner, TAccountSharedEscrow, TAccountCosigner, TAccountRentPayer>>;
export type BidInput<TAccountSystemProgram extends string = string, TAccountMarketplaceProgram extends string = string, TAccountBidState extends string = string, TAccountOwner extends string = string, TAccountSharedEscrow extends string = string, TAccountCosigner extends string = string, TAccountRentPayer extends string = string> = {
    systemProgram?: Address<TAccountSystemProgram>;
    marketplaceProgram?: Address<TAccountMarketplaceProgram>;
    bidState: Address<TAccountBidState>;
    owner: TransactionSigner<TAccountOwner>;
    sharedEscrow?: Address<TAccountSharedEscrow>;
    cosigner?: TransactionSigner<TAccountCosigner>;
    rentPayer?: TransactionSigner<TAccountRentPayer>;
    bidId?: BidInstructionDataArgs['bidId'];
    target: BidInstructionDataArgs['target'];
    targetId: BidInstructionDataArgs['targetId'];
    field?: BidInstructionDataArgs['field'];
    fieldId?: BidInstructionDataArgs['fieldId'];
    amount: BidInstructionDataArgs['amount'];
    quantity?: BidInstructionDataArgs['quantity'];
    expireInSec?: BidInstructionDataArgs['expireInSec'];
    currency?: BidInstructionDataArgs['currency'];
    privateTaker?: BidInstructionDataArgs['privateTaker'];
    makerBroker?: BidInstructionDataArgs['makerBroker'];
};
export declare function getBidInstruction<TAccountSystemProgram extends string, TAccountMarketplaceProgram extends string, TAccountBidState extends string, TAccountOwner extends string, TAccountSharedEscrow extends string, TAccountCosigner extends string, TAccountRentPayer extends string>(input: BidInput<TAccountSystemProgram, TAccountMarketplaceProgram, TAccountBidState, TAccountOwner, TAccountSharedEscrow, TAccountCosigner, TAccountRentPayer>): BidInstruction<typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountSystemProgram, TAccountMarketplaceProgram, TAccountBidState, TAccountOwner, TAccountSharedEscrow, TAccountCosigner, TAccountRentPayer>;
export type ParsedBidInstruction<TProgram extends string = typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        systemProgram: TAccountMetas[0];
        marketplaceProgram: TAccountMetas[1];
        bidState: TAccountMetas[2];
        owner: TAccountMetas[3];
        sharedEscrow: TAccountMetas[4];
        cosigner?: TAccountMetas[5] | undefined;
        rentPayer: TAccountMetas[6];
    };
    data: BidInstructionData;
};
export declare function parseBidInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedBidInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=bid.d.ts.map