/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, Option, OptionOrNullable, ReadonlyAccount, ReadonlySignerAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_MARKETPLACE_PROGRAM_ADDRESS } from '../programs';
export type BuyCompressedInstruction<TProgram extends string = typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountFeeVault extends string | IAccountMeta<string> = string, TAccountTreeAuthority extends string | IAccountMeta<string> = string, TAccountMerkleTree extends string | IAccountMeta<string> = string, TAccountLogWrapper extends string | IAccountMeta<string> = 'noopb9bkMVfRPU8AsbpTUg8AQkHtKwMYZiFUjNRtMmV', TAccountCompressionProgram extends string | IAccountMeta<string> = 'cmtDvXumGCrqC1Age74AVPhSRVXJMd8PJS91L8KbNCK', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountBubblegumProgram extends string | IAccountMeta<string> = 'BGUMAp9Gq7iTEuizy4pqaxsTyUCBK68MDfK752saRPUY', TAccountMarketplaceProgram extends string | IAccountMeta<string> = 'TCMPhJdwDryooaGtiocG1u3xcYbRpiJzb283XfCZsDp', TAccountListState extends string | IAccountMeta<string> = string, TAccountBuyer extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountTakerBroker extends string | IAccountMeta<string> = string, TAccountMakerBroker extends string | IAccountMeta<string> = string, TAccountRentDestination extends string | IAccountMeta<string> = string, TAccountCosigner extends string | IAccountMeta<string> = 'TCMPhJdwDryooaGtiocG1u3xcYbRpiJzb283XfCZsDp', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountFeeVault extends string ? WritableAccount<TAccountFeeVault> : TAccountFeeVault,
    TAccountTreeAuthority extends string ? ReadonlyAccount<TAccountTreeAuthority> : TAccountTreeAuthority,
    TAccountMerkleTree extends string ? WritableAccount<TAccountMerkleTree> : TAccountMerkleTree,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    TAccountCompressionProgram extends string ? ReadonlyAccount<TAccountCompressionProgram> : TAccountCompressionProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountBubblegumProgram extends string ? ReadonlyAccount<TAccountBubblegumProgram> : TAccountBubblegumProgram,
    TAccountMarketplaceProgram extends string ? ReadonlyAccount<TAccountMarketplaceProgram> : TAccountMarketplaceProgram,
    TAccountListState extends string ? WritableAccount<TAccountListState> : TAccountListState,
    TAccountBuyer extends string ? ReadonlyAccount<TAccountBuyer> : TAccountBuyer,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountOwner extends string ? WritableAccount<TAccountOwner> : TAccountOwner,
    TAccountTakerBroker extends string ? WritableAccount<TAccountTakerBroker> : TAccountTakerBroker,
    TAccountMakerBroker extends string ? WritableAccount<TAccountMakerBroker> : TAccountMakerBroker,
    TAccountRentDestination extends string ? WritableAccount<TAccountRentDestination> : TAccountRentDestination,
    TAccountCosigner extends string ? ReadonlySignerAccount<TAccountCosigner> & IAccountSignerMeta<TAccountCosigner> : TAccountCosigner,
    ...TRemainingAccounts
]>;
export type BuyCompressedInstructionData = {
    discriminator: ReadonlyUint8Array;
    nonce: bigint;
    index: number;
    root: ReadonlyUint8Array;
    metaHash: ReadonlyUint8Array;
    creatorShares: ReadonlyUint8Array;
    creatorVerified: Array<boolean>;
    sellerFeeBasisPoints: number;
    maxAmount: bigint;
    optionalRoyaltyPct: Option<number>;
};
export type BuyCompressedInstructionDataArgs = {
    nonce: number | bigint;
    index: number;
    root: ReadonlyUint8Array;
    metaHash: ReadonlyUint8Array;
    creatorShares: ReadonlyUint8Array;
    creatorVerified: Array<boolean>;
    sellerFeeBasisPoints: number;
    maxAmount: number | bigint;
    optionalRoyaltyPct?: OptionOrNullable<number>;
};
export declare function getBuyCompressedInstructionDataEncoder(): Encoder<BuyCompressedInstructionDataArgs>;
export declare function getBuyCompressedInstructionDataDecoder(): Decoder<BuyCompressedInstructionData>;
export declare function getBuyCompressedInstructionDataCodec(): Codec<BuyCompressedInstructionDataArgs, BuyCompressedInstructionData>;
export type BuyCompressedInstructionExtraArgs = {
    /** creators, structured like [ [creator_pubkey_1,creator_shares_1], ..., [creator_pubkey_n, creator_shares_n] ] */
    creators?: Array<readonly [Address, number]>;
    /** proof path, can be shortened if canopyDepth of merkle tree is also specified */
    proof?: Array<Address>;
    /** canopy depth of merkle tree, reduces proofPath length if specified */
    canopyDepth?: number;
};
export type BuyCompressedAsyncInput<TAccountFeeVault extends string = string, TAccountTreeAuthority extends string = string, TAccountMerkleTree extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountSystemProgram extends string = string, TAccountBubblegumProgram extends string = string, TAccountMarketplaceProgram extends string = string, TAccountListState extends string = string, TAccountBuyer extends string = string, TAccountPayer extends string = string, TAccountOwner extends string = string, TAccountTakerBroker extends string = string, TAccountMakerBroker extends string = string, TAccountRentDestination extends string = string, TAccountCosigner extends string = string> = {
    feeVault?: Address<TAccountFeeVault>;
    treeAuthority?: Address<TAccountTreeAuthority>;
    merkleTree: Address<TAccountMerkleTree>;
    logWrapper?: Address<TAccountLogWrapper>;
    compressionProgram?: Address<TAccountCompressionProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    bubblegumProgram?: Address<TAccountBubblegumProgram>;
    marketplaceProgram?: Address<TAccountMarketplaceProgram>;
    listState: Address<TAccountListState>;
    buyer?: Address<TAccountBuyer>;
    payer: TransactionSigner<TAccountPayer>;
    owner: Address<TAccountOwner>;
    takerBroker?: Address<TAccountTakerBroker>;
    makerBroker?: Address<TAccountMakerBroker>;
    rentDestination?: Address<TAccountRentDestination>;
    cosigner?: TransactionSigner<TAccountCosigner>;
    nonce?: BuyCompressedInstructionDataArgs['nonce'];
    index: BuyCompressedInstructionDataArgs['index'];
    root: BuyCompressedInstructionDataArgs['root'];
    metaHash: BuyCompressedInstructionDataArgs['metaHash'];
    creatorShares: BuyCompressedInstructionDataArgs['creatorShares'];
    creatorVerified: BuyCompressedInstructionDataArgs['creatorVerified'];
    sellerFeeBasisPoints: BuyCompressedInstructionDataArgs['sellerFeeBasisPoints'];
    maxAmount: BuyCompressedInstructionDataArgs['maxAmount'];
    optionalRoyaltyPct?: BuyCompressedInstructionDataArgs['optionalRoyaltyPct'];
    creators?: BuyCompressedInstructionExtraArgs['creators'];
    proof?: BuyCompressedInstructionExtraArgs['proof'];
    canopyDepth?: BuyCompressedInstructionExtraArgs['canopyDepth'];
};
export declare function getBuyCompressedInstructionAsync<TAccountFeeVault extends string, TAccountTreeAuthority extends string, TAccountMerkleTree extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountSystemProgram extends string, TAccountBubblegumProgram extends string, TAccountMarketplaceProgram extends string, TAccountListState extends string, TAccountBuyer extends string, TAccountPayer extends string, TAccountOwner extends string, TAccountTakerBroker extends string, TAccountMakerBroker extends string, TAccountRentDestination extends string, TAccountCosigner extends string>(input: BuyCompressedAsyncInput<TAccountFeeVault, TAccountTreeAuthority, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountListState, TAccountBuyer, TAccountPayer, TAccountOwner, TAccountTakerBroker, TAccountMakerBroker, TAccountRentDestination, TAccountCosigner>): Promise<BuyCompressedInstruction<typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountFeeVault, TAccountTreeAuthority, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountListState, TAccountBuyer, TAccountPayer, TAccountOwner, TAccountTakerBroker, TAccountMakerBroker, TAccountRentDestination, TAccountCosigner>>;
export type BuyCompressedInput<TAccountFeeVault extends string = string, TAccountTreeAuthority extends string = string, TAccountMerkleTree extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountSystemProgram extends string = string, TAccountBubblegumProgram extends string = string, TAccountMarketplaceProgram extends string = string, TAccountListState extends string = string, TAccountBuyer extends string = string, TAccountPayer extends string = string, TAccountOwner extends string = string, TAccountTakerBroker extends string = string, TAccountMakerBroker extends string = string, TAccountRentDestination extends string = string, TAccountCosigner extends string = string> = {
    feeVault: Address<TAccountFeeVault>;
    treeAuthority: Address<TAccountTreeAuthority>;
    merkleTree: Address<TAccountMerkleTree>;
    logWrapper?: Address<TAccountLogWrapper>;
    compressionProgram?: Address<TAccountCompressionProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    bubblegumProgram?: Address<TAccountBubblegumProgram>;
    marketplaceProgram?: Address<TAccountMarketplaceProgram>;
    listState: Address<TAccountListState>;
    buyer?: Address<TAccountBuyer>;
    payer: TransactionSigner<TAccountPayer>;
    owner: Address<TAccountOwner>;
    takerBroker?: Address<TAccountTakerBroker>;
    makerBroker?: Address<TAccountMakerBroker>;
    rentDestination?: Address<TAccountRentDestination>;
    cosigner?: TransactionSigner<TAccountCosigner>;
    nonce?: BuyCompressedInstructionDataArgs['nonce'];
    index: BuyCompressedInstructionDataArgs['index'];
    root: BuyCompressedInstructionDataArgs['root'];
    metaHash: BuyCompressedInstructionDataArgs['metaHash'];
    creatorShares: BuyCompressedInstructionDataArgs['creatorShares'];
    creatorVerified: BuyCompressedInstructionDataArgs['creatorVerified'];
    sellerFeeBasisPoints: BuyCompressedInstructionDataArgs['sellerFeeBasisPoints'];
    maxAmount: BuyCompressedInstructionDataArgs['maxAmount'];
    optionalRoyaltyPct?: BuyCompressedInstructionDataArgs['optionalRoyaltyPct'];
    creators?: BuyCompressedInstructionExtraArgs['creators'];
    proof?: BuyCompressedInstructionExtraArgs['proof'];
    canopyDepth?: BuyCompressedInstructionExtraArgs['canopyDepth'];
};
export declare function getBuyCompressedInstruction<TAccountFeeVault extends string, TAccountTreeAuthority extends string, TAccountMerkleTree extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountSystemProgram extends string, TAccountBubblegumProgram extends string, TAccountMarketplaceProgram extends string, TAccountListState extends string, TAccountBuyer extends string, TAccountPayer extends string, TAccountOwner extends string, TAccountTakerBroker extends string, TAccountMakerBroker extends string, TAccountRentDestination extends string, TAccountCosigner extends string>(input: BuyCompressedInput<TAccountFeeVault, TAccountTreeAuthority, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountListState, TAccountBuyer, TAccountPayer, TAccountOwner, TAccountTakerBroker, TAccountMakerBroker, TAccountRentDestination, TAccountCosigner>): BuyCompressedInstruction<typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountFeeVault, TAccountTreeAuthority, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountListState, TAccountBuyer, TAccountPayer, TAccountOwner, TAccountTakerBroker, TAccountMakerBroker, TAccountRentDestination, TAccountCosigner>;
export type ParsedBuyCompressedInstruction<TProgram extends string = typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        feeVault: TAccountMetas[0];
        treeAuthority: TAccountMetas[1];
        merkleTree: TAccountMetas[2];
        logWrapper: TAccountMetas[3];
        compressionProgram: TAccountMetas[4];
        systemProgram: TAccountMetas[5];
        bubblegumProgram: TAccountMetas[6];
        marketplaceProgram: TAccountMetas[7];
        listState: TAccountMetas[8];
        buyer: TAccountMetas[9];
        payer: TAccountMetas[10];
        owner: TAccountMetas[11];
        takerBroker?: TAccountMetas[12] | undefined;
        makerBroker?: TAccountMetas[13] | undefined;
        rentDestination: TAccountMetas[14];
        cosigner?: TAccountMetas[15] | undefined;
    };
    data: BuyCompressedInstructionData;
};
export declare function parseBuyCompressedInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedBuyCompressedInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=buyCompressed.d.ts.map