/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, Option, OptionOrNullable, ReadonlyAccount, ReadonlySignerAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_MARKETPLACE_PROGRAM_ADDRESS } from '../programs';
import { TCollection, TCollectionArgs, TTokenProgramVersion, TTokenProgramVersionArgs, TTokenStandard, TTokenStandardArgs, TUses, TUsesArgs } from '../types';
export type TakeBidCompressedFullMetaInstruction<TProgram extends string = typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountFeeVault extends string | IAccountMeta<string> = string, TAccountTreeAuthority extends string | IAccountMeta<string> = string, TAccountSeller extends string | IAccountMeta<string> = string, TAccountDelegate extends string | IAccountMeta<string> = string, TAccountMerkleTree extends string | IAccountMeta<string> = string, TAccountLogWrapper extends string | IAccountMeta<string> = 'noopb9bkMVfRPU8AsbpTUg8AQkHtKwMYZiFUjNRtMmV', TAccountCompressionProgram extends string | IAccountMeta<string> = 'cmtDvXumGCrqC1Age74AVPhSRVXJMd8PJS91L8KbNCK', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountBubblegumProgram extends string | IAccountMeta<string> = 'BGUMAp9Gq7iTEuizy4pqaxsTyUCBK68MDfK752saRPUY', TAccountMarketplaceProgram extends string | IAccountMeta<string> = 'TCMPhJdwDryooaGtiocG1u3xcYbRpiJzb283XfCZsDp', TAccountTensorswapProgram extends string | IAccountMeta<string> = 'TSWAPaqyCSx2KABk68Shruf4rp7CxcNi8hAsbdwmHbN', TAccountBidState extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountTakerBroker extends string | IAccountMeta<string> = string, TAccountMakerBroker extends string | IAccountMeta<string> = string, TAccountMarginAccount extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountCosigner extends string | IAccountMeta<string> = string, TAccountRentDestination extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountFeeVault extends string ? WritableAccount<TAccountFeeVault> : TAccountFeeVault,
    TAccountTreeAuthority extends string ? ReadonlyAccount<TAccountTreeAuthority> : TAccountTreeAuthority,
    TAccountSeller extends string ? WritableAccount<TAccountSeller> : TAccountSeller,
    TAccountDelegate extends string ? ReadonlyAccount<TAccountDelegate> : TAccountDelegate,
    TAccountMerkleTree extends string ? WritableAccount<TAccountMerkleTree> : TAccountMerkleTree,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    TAccountCompressionProgram extends string ? ReadonlyAccount<TAccountCompressionProgram> : TAccountCompressionProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountBubblegumProgram extends string ? ReadonlyAccount<TAccountBubblegumProgram> : TAccountBubblegumProgram,
    TAccountMarketplaceProgram extends string ? ReadonlyAccount<TAccountMarketplaceProgram> : TAccountMarketplaceProgram,
    TAccountTensorswapProgram extends string ? ReadonlyAccount<TAccountTensorswapProgram> : TAccountTensorswapProgram,
    TAccountBidState extends string ? WritableAccount<TAccountBidState> : TAccountBidState,
    TAccountOwner extends string ? WritableAccount<TAccountOwner> : TAccountOwner,
    TAccountTakerBroker extends string ? WritableAccount<TAccountTakerBroker> : TAccountTakerBroker,
    TAccountMakerBroker extends string ? WritableAccount<TAccountMakerBroker> : TAccountMakerBroker,
    TAccountMarginAccount extends string ? WritableAccount<TAccountMarginAccount> : TAccountMarginAccount,
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountCosigner extends string ? ReadonlySignerAccount<TAccountCosigner> & IAccountSignerMeta<TAccountCosigner> : TAccountCosigner,
    TAccountRentDestination extends string ? WritableAccount<TAccountRentDestination> : TAccountRentDestination,
    ...TRemainingAccounts
]>;
export type TakeBidCompressedFullMetaInstructionData = {
    discriminator: ReadonlyUint8Array;
    nonce: bigint;
    index: number;
    root: ReadonlyUint8Array;
    /** The name of the asset */
    name: string;
    /** The symbol for the asset */
    symbol: string;
    /** URI pointing to JSON representing the asset */
    uri: string;
    /** Royalty basis points that goes to creators in secondary sales (0-10000) */
    sellerFeeBasisPoints: number;
    primarySaleHappened: boolean;
    isMutable: boolean;
    /** nonce for easy calculation of editions, if present */
    editionNonce: Option<number>;
    /** Since we cannot easily change Metadata, we add the new DataV2 fields here at the end. */
    tokenStandard: Option<TTokenStandard>;
    /** Collection */
    collection: Option<TCollection>;
    /** Uses */
    uses: Option<TUses>;
    tokenProgramVersion: TTokenProgramVersion;
    creatorShares: ReadonlyUint8Array;
    creatorVerified: Array<boolean>;
    minAmount: bigint;
    optionalRoyaltyPct: Option<number>;
};
export type TakeBidCompressedFullMetaInstructionDataArgs = {
    nonce: number | bigint;
    index: number;
    root: ReadonlyUint8Array;
    /** The name of the asset */
    name: string;
    /** The symbol for the asset */
    symbol: string;
    /** URI pointing to JSON representing the asset */
    uri: string;
    /** Royalty basis points that goes to creators in secondary sales (0-10000) */
    sellerFeeBasisPoints: number;
    primarySaleHappened: boolean;
    isMutable: boolean;
    /** nonce for easy calculation of editions, if present */
    editionNonce: OptionOrNullable<number>;
    /** Since we cannot easily change Metadata, we add the new DataV2 fields here at the end. */
    tokenStandard: OptionOrNullable<TTokenStandardArgs>;
    /** Collection */
    collection: OptionOrNullable<TCollectionArgs>;
    /** Uses */
    uses: OptionOrNullable<TUsesArgs>;
    tokenProgramVersion: TTokenProgramVersionArgs;
    creatorShares: ReadonlyUint8Array;
    creatorVerified: Array<boolean>;
    minAmount: number | bigint;
    optionalRoyaltyPct?: OptionOrNullable<number>;
};
export declare function getTakeBidCompressedFullMetaInstructionDataEncoder(): Encoder<TakeBidCompressedFullMetaInstructionDataArgs>;
export declare function getTakeBidCompressedFullMetaInstructionDataDecoder(): Decoder<TakeBidCompressedFullMetaInstructionData>;
export declare function getTakeBidCompressedFullMetaInstructionDataCodec(): Codec<TakeBidCompressedFullMetaInstructionDataArgs, TakeBidCompressedFullMetaInstructionData>;
export type TakeBidCompressedFullMetaInstructionExtraArgs = {
    /** creators, structured like [ [creator_pubkey_1,creator_shares_1], ..., [creator_pubkey_n, creator_shares_n] ] */
    creators?: Array<readonly [Address, number]>;
    /** proof path, can be shortened if canopyDepth of merkle tree is also specified */
    proof?: Array<Address>;
    /** canopy depth of merkle tree, reduces proofPath length if specified */
    canopyDepth?: number;
};
export type TakeBidCompressedFullMetaAsyncInput<TAccountFeeVault extends string = string, TAccountTreeAuthority extends string = string, TAccountSeller extends string = string, TAccountDelegate extends string = string, TAccountMerkleTree extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountSystemProgram extends string = string, TAccountBubblegumProgram extends string = string, TAccountMarketplaceProgram extends string = string, TAccountTensorswapProgram extends string = string, TAccountBidState extends string = string, TAccountOwner extends string = string, TAccountTakerBroker extends string = string, TAccountMakerBroker extends string = string, TAccountMarginAccount extends string = string, TAccountWhitelist extends string = string, TAccountCosigner extends string = string, TAccountRentDestination extends string = string> = {
    feeVault?: Address<TAccountFeeVault>;
    treeAuthority?: Address<TAccountTreeAuthority>;
    seller: Address<TAccountSeller> | TransactionSigner<TAccountSeller>;
    delegate?: Address<TAccountDelegate> | TransactionSigner<TAccountDelegate>;
    merkleTree: Address<TAccountMerkleTree>;
    logWrapper?: Address<TAccountLogWrapper>;
    compressionProgram?: Address<TAccountCompressionProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    bubblegumProgram?: Address<TAccountBubblegumProgram>;
    marketplaceProgram?: Address<TAccountMarketplaceProgram>;
    tensorswapProgram?: Address<TAccountTensorswapProgram>;
    bidState: Address<TAccountBidState>;
    owner: Address<TAccountOwner>;
    takerBroker?: Address<TAccountTakerBroker>;
    makerBroker?: Address<TAccountMakerBroker>;
    marginAccount?: Address<TAccountMarginAccount>;
    whitelist: Address<TAccountWhitelist>;
    cosigner?: TransactionSigner<TAccountCosigner>;
    rentDestination?: Address<TAccountRentDestination>;
    nonce?: TakeBidCompressedFullMetaInstructionDataArgs['nonce'];
    index: TakeBidCompressedFullMetaInstructionDataArgs['index'];
    root: TakeBidCompressedFullMetaInstructionDataArgs['root'];
    name: TakeBidCompressedFullMetaInstructionDataArgs['name'];
    symbol: TakeBidCompressedFullMetaInstructionDataArgs['symbol'];
    uri: TakeBidCompressedFullMetaInstructionDataArgs['uri'];
    sellerFeeBasisPoints: TakeBidCompressedFullMetaInstructionDataArgs['sellerFeeBasisPoints'];
    primarySaleHappened: TakeBidCompressedFullMetaInstructionDataArgs['primarySaleHappened'];
    isMutable: TakeBidCompressedFullMetaInstructionDataArgs['isMutable'];
    editionNonce: TakeBidCompressedFullMetaInstructionDataArgs['editionNonce'];
    tokenStandard: TakeBidCompressedFullMetaInstructionDataArgs['tokenStandard'];
    collection: TakeBidCompressedFullMetaInstructionDataArgs['collection'];
    uses: TakeBidCompressedFullMetaInstructionDataArgs['uses'];
    tokenProgramVersion: TakeBidCompressedFullMetaInstructionDataArgs['tokenProgramVersion'];
    creatorShares: TakeBidCompressedFullMetaInstructionDataArgs['creatorShares'];
    creatorVerified: TakeBidCompressedFullMetaInstructionDataArgs['creatorVerified'];
    minAmount: TakeBidCompressedFullMetaInstructionDataArgs['minAmount'];
    optionalRoyaltyPct?: TakeBidCompressedFullMetaInstructionDataArgs['optionalRoyaltyPct'];
    creators?: TakeBidCompressedFullMetaInstructionExtraArgs['creators'];
    proof?: TakeBidCompressedFullMetaInstructionExtraArgs['proof'];
    canopyDepth?: TakeBidCompressedFullMetaInstructionExtraArgs['canopyDepth'];
};
export declare function getTakeBidCompressedFullMetaInstructionAsync<TAccountFeeVault extends string, TAccountTreeAuthority extends string, TAccountSeller extends string, TAccountDelegate extends string, TAccountMerkleTree extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountSystemProgram extends string, TAccountBubblegumProgram extends string, TAccountMarketplaceProgram extends string, TAccountTensorswapProgram extends string, TAccountBidState extends string, TAccountOwner extends string, TAccountTakerBroker extends string, TAccountMakerBroker extends string, TAccountMarginAccount extends string, TAccountWhitelist extends string, TAccountCosigner extends string, TAccountRentDestination extends string>(input: TakeBidCompressedFullMetaAsyncInput<TAccountFeeVault, TAccountTreeAuthority, TAccountSeller, TAccountDelegate, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountTensorswapProgram, TAccountBidState, TAccountOwner, TAccountTakerBroker, TAccountMakerBroker, TAccountMarginAccount, TAccountWhitelist, TAccountCosigner, TAccountRentDestination>): Promise<TakeBidCompressedFullMetaInstruction<typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountFeeVault, TAccountTreeAuthority, (typeof input)['seller'] extends TransactionSigner<TAccountSeller> ? WritableSignerAccount<TAccountSeller> & IAccountSignerMeta<TAccountSeller> : TAccountSeller, (typeof input)['delegate'] extends TransactionSigner<TAccountDelegate> ? ReadonlySignerAccount<TAccountDelegate> & IAccountSignerMeta<TAccountDelegate> : TAccountDelegate, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountTensorswapProgram, TAccountBidState, TAccountOwner, TAccountTakerBroker, TAccountMakerBroker, TAccountMarginAccount, TAccountWhitelist, TAccountCosigner, TAccountRentDestination>>;
export type TakeBidCompressedFullMetaInput<TAccountFeeVault extends string = string, TAccountTreeAuthority extends string = string, TAccountSeller extends string = string, TAccountDelegate extends string = string, TAccountMerkleTree extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountSystemProgram extends string = string, TAccountBubblegumProgram extends string = string, TAccountMarketplaceProgram extends string = string, TAccountTensorswapProgram extends string = string, TAccountBidState extends string = string, TAccountOwner extends string = string, TAccountTakerBroker extends string = string, TAccountMakerBroker extends string = string, TAccountMarginAccount extends string = string, TAccountWhitelist extends string = string, TAccountCosigner extends string = string, TAccountRentDestination extends string = string> = {
    feeVault: Address<TAccountFeeVault>;
    treeAuthority: Address<TAccountTreeAuthority>;
    seller: Address<TAccountSeller> | TransactionSigner<TAccountSeller>;
    delegate?: Address<TAccountDelegate> | TransactionSigner<TAccountDelegate>;
    merkleTree: Address<TAccountMerkleTree>;
    logWrapper?: Address<TAccountLogWrapper>;
    compressionProgram?: Address<TAccountCompressionProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    bubblegumProgram?: Address<TAccountBubblegumProgram>;
    marketplaceProgram?: Address<TAccountMarketplaceProgram>;
    tensorswapProgram?: Address<TAccountTensorswapProgram>;
    bidState: Address<TAccountBidState>;
    owner: Address<TAccountOwner>;
    takerBroker?: Address<TAccountTakerBroker>;
    makerBroker?: Address<TAccountMakerBroker>;
    marginAccount?: Address<TAccountMarginAccount>;
    whitelist: Address<TAccountWhitelist>;
    cosigner?: TransactionSigner<TAccountCosigner>;
    rentDestination?: Address<TAccountRentDestination>;
    nonce?: TakeBidCompressedFullMetaInstructionDataArgs['nonce'];
    index: TakeBidCompressedFullMetaInstructionDataArgs['index'];
    root: TakeBidCompressedFullMetaInstructionDataArgs['root'];
    name: TakeBidCompressedFullMetaInstructionDataArgs['name'];
    symbol: TakeBidCompressedFullMetaInstructionDataArgs['symbol'];
    uri: TakeBidCompressedFullMetaInstructionDataArgs['uri'];
    sellerFeeBasisPoints: TakeBidCompressedFullMetaInstructionDataArgs['sellerFeeBasisPoints'];
    primarySaleHappened: TakeBidCompressedFullMetaInstructionDataArgs['primarySaleHappened'];
    isMutable: TakeBidCompressedFullMetaInstructionDataArgs['isMutable'];
    editionNonce: TakeBidCompressedFullMetaInstructionDataArgs['editionNonce'];
    tokenStandard: TakeBidCompressedFullMetaInstructionDataArgs['tokenStandard'];
    collection: TakeBidCompressedFullMetaInstructionDataArgs['collection'];
    uses: TakeBidCompressedFullMetaInstructionDataArgs['uses'];
    tokenProgramVersion: TakeBidCompressedFullMetaInstructionDataArgs['tokenProgramVersion'];
    creatorShares: TakeBidCompressedFullMetaInstructionDataArgs['creatorShares'];
    creatorVerified: TakeBidCompressedFullMetaInstructionDataArgs['creatorVerified'];
    minAmount: TakeBidCompressedFullMetaInstructionDataArgs['minAmount'];
    optionalRoyaltyPct?: TakeBidCompressedFullMetaInstructionDataArgs['optionalRoyaltyPct'];
    creators?: TakeBidCompressedFullMetaInstructionExtraArgs['creators'];
    proof?: TakeBidCompressedFullMetaInstructionExtraArgs['proof'];
    canopyDepth?: TakeBidCompressedFullMetaInstructionExtraArgs['canopyDepth'];
};
export declare function getTakeBidCompressedFullMetaInstruction<TAccountFeeVault extends string, TAccountTreeAuthority extends string, TAccountSeller extends string, TAccountDelegate extends string, TAccountMerkleTree extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountSystemProgram extends string, TAccountBubblegumProgram extends string, TAccountMarketplaceProgram extends string, TAccountTensorswapProgram extends string, TAccountBidState extends string, TAccountOwner extends string, TAccountTakerBroker extends string, TAccountMakerBroker extends string, TAccountMarginAccount extends string, TAccountWhitelist extends string, TAccountCosigner extends string, TAccountRentDestination extends string>(input: TakeBidCompressedFullMetaInput<TAccountFeeVault, TAccountTreeAuthority, TAccountSeller, TAccountDelegate, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountTensorswapProgram, TAccountBidState, TAccountOwner, TAccountTakerBroker, TAccountMakerBroker, TAccountMarginAccount, TAccountWhitelist, TAccountCosigner, TAccountRentDestination>): TakeBidCompressedFullMetaInstruction<typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountFeeVault, TAccountTreeAuthority, (typeof input)['seller'] extends TransactionSigner<TAccountSeller> ? WritableSignerAccount<TAccountSeller> & IAccountSignerMeta<TAccountSeller> : TAccountSeller, (typeof input)['delegate'] extends TransactionSigner<TAccountDelegate> ? ReadonlySignerAccount<TAccountDelegate> & IAccountSignerMeta<TAccountDelegate> : TAccountDelegate, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountTensorswapProgram, TAccountBidState, TAccountOwner, TAccountTakerBroker, TAccountMakerBroker, TAccountMarginAccount, TAccountWhitelist, TAccountCosigner, TAccountRentDestination>;
export type ParsedTakeBidCompressedFullMetaInstruction<TProgram extends string = typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        feeVault: TAccountMetas[0];
        treeAuthority: TAccountMetas[1];
        seller: TAccountMetas[2];
        delegate: TAccountMetas[3];
        merkleTree: TAccountMetas[4];
        logWrapper: TAccountMetas[5];
        compressionProgram: TAccountMetas[6];
        systemProgram: TAccountMetas[7];
        bubblegumProgram: TAccountMetas[8];
        marketplaceProgram: TAccountMetas[9];
        tensorswapProgram: TAccountMetas[10];
        bidState: TAccountMetas[11];
        owner: TAccountMetas[12];
        takerBroker?: TAccountMetas[13] | undefined;
        makerBroker?: TAccountMetas[14] | undefined;
        marginAccount: TAccountMetas[15];
        whitelist: TAccountMetas[16];
        cosigner?: TAccountMetas[17] | undefined;
        rentDestination: TAccountMetas[18];
    };
    data: TakeBidCompressedFullMetaInstructionData;
};
export declare function parseTakeBidCompressedFullMetaInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedTakeBidCompressedFullMetaInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=takeBidCompressedFullMeta.d.ts.map