/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { Address, Codec, Decoder, Encoder, IAccountMeta, IAccountSignerMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, Option, OptionOrNullable, ReadonlyAccount, ReadonlySignerAccount, ReadonlyUint8Array, TransactionSigner, WritableAccount, WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_MARKETPLACE_PROGRAM_ADDRESS } from '../programs';
export type TakeBidCompressedMetaHashInstruction<TProgram extends string = typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountFeeVault extends string | IAccountMeta<string> = string, TAccountTreeAuthority extends string | IAccountMeta<string> = string, TAccountSeller extends string | IAccountMeta<string> = string, TAccountDelegate extends string | IAccountMeta<string> = string, TAccountMerkleTree extends string | IAccountMeta<string> = string, TAccountLogWrapper extends string | IAccountMeta<string> = 'noopb9bkMVfRPU8AsbpTUg8AQkHtKwMYZiFUjNRtMmV', TAccountCompressionProgram extends string | IAccountMeta<string> = 'cmtDvXumGCrqC1Age74AVPhSRVXJMd8PJS91L8KbNCK', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountBubblegumProgram extends string | IAccountMeta<string> = 'BGUMAp9Gq7iTEuizy4pqaxsTyUCBK68MDfK752saRPUY', TAccountMarketplaceProgram extends string | IAccountMeta<string> = 'TCMPhJdwDryooaGtiocG1u3xcYbRpiJzb283XfCZsDp', TAccountTensorswapProgram extends string | IAccountMeta<string> = 'TSWAPaqyCSx2KABk68Shruf4rp7CxcNi8hAsbdwmHbN', TAccountBidState extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountTakerBroker extends string | IAccountMeta<string> = string, TAccountMakerBroker extends string | IAccountMeta<string> = string, TAccountMarginAccount extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountCosigner extends string | IAccountMeta<string> = string, TAccountRentDestination extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountFeeVault extends string ? WritableAccount<TAccountFeeVault> : TAccountFeeVault,
    TAccountTreeAuthority extends string ? ReadonlyAccount<TAccountTreeAuthority> : TAccountTreeAuthority,
    TAccountSeller extends string ? WritableAccount<TAccountSeller> : TAccountSeller,
    TAccountDelegate extends string ? ReadonlyAccount<TAccountDelegate> : TAccountDelegate,
    TAccountMerkleTree extends string ? WritableAccount<TAccountMerkleTree> : TAccountMerkleTree,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    TAccountCompressionProgram extends string ? ReadonlyAccount<TAccountCompressionProgram> : TAccountCompressionProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountBubblegumProgram extends string ? ReadonlyAccount<TAccountBubblegumProgram> : TAccountBubblegumProgram,
    TAccountMarketplaceProgram extends string ? ReadonlyAccount<TAccountMarketplaceProgram> : TAccountMarketplaceProgram,
    TAccountTensorswapProgram extends string ? ReadonlyAccount<TAccountTensorswapProgram> : TAccountTensorswapProgram,
    TAccountBidState extends string ? WritableAccount<TAccountBidState> : TAccountBidState,
    TAccountOwner extends string ? WritableAccount<TAccountOwner> : TAccountOwner,
    TAccountTakerBroker extends string ? WritableAccount<TAccountTakerBroker> : TAccountTakerBroker,
    TAccountMakerBroker extends string ? WritableAccount<TAccountMakerBroker> : TAccountMakerBroker,
    TAccountMarginAccount extends string ? WritableAccount<TAccountMarginAccount> : TAccountMarginAccount,
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountCosigner extends string ? ReadonlySignerAccount<TAccountCosigner> & IAccountSignerMeta<TAccountCosigner> : TAccountCosigner,
    TAccountRentDestination extends string ? WritableAccount<TAccountRentDestination> : TAccountRentDestination,
    ...TRemainingAccounts
]>;
export type TakeBidCompressedMetaHashInstructionData = {
    discriminator: ReadonlyUint8Array;
    nonce: bigint;
    index: number;
    root: ReadonlyUint8Array;
    metaHash: ReadonlyUint8Array;
    creatorShares: ReadonlyUint8Array;
    creatorVerified: Array<boolean>;
    sellerFeeBasisPoints: number;
    minAmount: bigint;
    optionalRoyaltyPct: Option<number>;
};
export type TakeBidCompressedMetaHashInstructionDataArgs = {
    nonce: number | bigint;
    index: number;
    root: ReadonlyUint8Array;
    metaHash: ReadonlyUint8Array;
    creatorShares: ReadonlyUint8Array;
    creatorVerified: Array<boolean>;
    sellerFeeBasisPoints: number;
    minAmount: number | bigint;
    optionalRoyaltyPct?: OptionOrNullable<number>;
};
export declare function getTakeBidCompressedMetaHashInstructionDataEncoder(): Encoder<TakeBidCompressedMetaHashInstructionDataArgs>;
export declare function getTakeBidCompressedMetaHashInstructionDataDecoder(): Decoder<TakeBidCompressedMetaHashInstructionData>;
export declare function getTakeBidCompressedMetaHashInstructionDataCodec(): Codec<TakeBidCompressedMetaHashInstructionDataArgs, TakeBidCompressedMetaHashInstructionData>;
export type TakeBidCompressedMetaHashInstructionExtraArgs = {
    /** creators, structured like [ [creator_pubkey_1,creator_shares_1], ..., [creator_pubkey_n, creator_shares_n] ] */
    creators?: Array<readonly [Address, number]>;
    /** proof path, can be shortened if canopyDepth of merkle tree is also specified */
    proof?: Array<Address>;
    /** canopy depth of merkle tree, reduces proofPath length if specified */
    canopyDepth?: number;
};
export type TakeBidCompressedMetaHashAsyncInput<TAccountFeeVault extends string = string, TAccountTreeAuthority extends string = string, TAccountSeller extends string = string, TAccountDelegate extends string = string, TAccountMerkleTree extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountSystemProgram extends string = string, TAccountBubblegumProgram extends string = string, TAccountMarketplaceProgram extends string = string, TAccountTensorswapProgram extends string = string, TAccountBidState extends string = string, TAccountOwner extends string = string, TAccountTakerBroker extends string = string, TAccountMakerBroker extends string = string, TAccountMarginAccount extends string = string, TAccountWhitelist extends string = string, TAccountCosigner extends string = string, TAccountRentDestination extends string = string> = {
    feeVault?: Address<TAccountFeeVault>;
    treeAuthority?: Address<TAccountTreeAuthority>;
    seller: Address<TAccountSeller> | TransactionSigner<TAccountSeller>;
    delegate?: Address<TAccountDelegate> | TransactionSigner<TAccountDelegate>;
    merkleTree: Address<TAccountMerkleTree>;
    logWrapper?: Address<TAccountLogWrapper>;
    compressionProgram?: Address<TAccountCompressionProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    bubblegumProgram?: Address<TAccountBubblegumProgram>;
    marketplaceProgram?: Address<TAccountMarketplaceProgram>;
    tensorswapProgram?: Address<TAccountTensorswapProgram>;
    bidState: Address<TAccountBidState>;
    owner: Address<TAccountOwner>;
    takerBroker?: Address<TAccountTakerBroker>;
    makerBroker?: Address<TAccountMakerBroker>;
    marginAccount?: Address<TAccountMarginAccount>;
    whitelist: Address<TAccountWhitelist>;
    cosigner?: TransactionSigner<TAccountCosigner>;
    rentDestination?: Address<TAccountRentDestination>;
    nonce?: TakeBidCompressedMetaHashInstructionDataArgs['nonce'];
    index: TakeBidCompressedMetaHashInstructionDataArgs['index'];
    root: TakeBidCompressedMetaHashInstructionDataArgs['root'];
    metaHash: TakeBidCompressedMetaHashInstructionDataArgs['metaHash'];
    creatorShares: TakeBidCompressedMetaHashInstructionDataArgs['creatorShares'];
    creatorVerified: TakeBidCompressedMetaHashInstructionDataArgs['creatorVerified'];
    sellerFeeBasisPoints: TakeBidCompressedMetaHashInstructionDataArgs['sellerFeeBasisPoints'];
    minAmount: TakeBidCompressedMetaHashInstructionDataArgs['minAmount'];
    optionalRoyaltyPct?: TakeBidCompressedMetaHashInstructionDataArgs['optionalRoyaltyPct'];
    creators?: TakeBidCompressedMetaHashInstructionExtraArgs['creators'];
    proof?: TakeBidCompressedMetaHashInstructionExtraArgs['proof'];
    canopyDepth?: TakeBidCompressedMetaHashInstructionExtraArgs['canopyDepth'];
};
export declare function getTakeBidCompressedMetaHashInstructionAsync<TAccountFeeVault extends string, TAccountTreeAuthority extends string, TAccountSeller extends string, TAccountDelegate extends string, TAccountMerkleTree extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountSystemProgram extends string, TAccountBubblegumProgram extends string, TAccountMarketplaceProgram extends string, TAccountTensorswapProgram extends string, TAccountBidState extends string, TAccountOwner extends string, TAccountTakerBroker extends string, TAccountMakerBroker extends string, TAccountMarginAccount extends string, TAccountWhitelist extends string, TAccountCosigner extends string, TAccountRentDestination extends string>(input: TakeBidCompressedMetaHashAsyncInput<TAccountFeeVault, TAccountTreeAuthority, TAccountSeller, TAccountDelegate, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountTensorswapProgram, TAccountBidState, TAccountOwner, TAccountTakerBroker, TAccountMakerBroker, TAccountMarginAccount, TAccountWhitelist, TAccountCosigner, TAccountRentDestination>): Promise<TakeBidCompressedMetaHashInstruction<typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountFeeVault, TAccountTreeAuthority, (typeof input)['seller'] extends TransactionSigner<TAccountSeller> ? WritableSignerAccount<TAccountSeller> & IAccountSignerMeta<TAccountSeller> : TAccountSeller, (typeof input)['delegate'] extends TransactionSigner<TAccountDelegate> ? ReadonlySignerAccount<TAccountDelegate> & IAccountSignerMeta<TAccountDelegate> : TAccountDelegate, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountTensorswapProgram, TAccountBidState, TAccountOwner, TAccountTakerBroker, TAccountMakerBroker, TAccountMarginAccount, TAccountWhitelist, TAccountCosigner, TAccountRentDestination>>;
export type TakeBidCompressedMetaHashInput<TAccountFeeVault extends string = string, TAccountTreeAuthority extends string = string, TAccountSeller extends string = string, TAccountDelegate extends string = string, TAccountMerkleTree extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountSystemProgram extends string = string, TAccountBubblegumProgram extends string = string, TAccountMarketplaceProgram extends string = string, TAccountTensorswapProgram extends string = string, TAccountBidState extends string = string, TAccountOwner extends string = string, TAccountTakerBroker extends string = string, TAccountMakerBroker extends string = string, TAccountMarginAccount extends string = string, TAccountWhitelist extends string = string, TAccountCosigner extends string = string, TAccountRentDestination extends string = string> = {
    feeVault: Address<TAccountFeeVault>;
    treeAuthority: Address<TAccountTreeAuthority>;
    seller: Address<TAccountSeller> | TransactionSigner<TAccountSeller>;
    delegate?: Address<TAccountDelegate> | TransactionSigner<TAccountDelegate>;
    merkleTree: Address<TAccountMerkleTree>;
    logWrapper?: Address<TAccountLogWrapper>;
    compressionProgram?: Address<TAccountCompressionProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    bubblegumProgram?: Address<TAccountBubblegumProgram>;
    marketplaceProgram?: Address<TAccountMarketplaceProgram>;
    tensorswapProgram?: Address<TAccountTensorswapProgram>;
    bidState: Address<TAccountBidState>;
    owner: Address<TAccountOwner>;
    takerBroker?: Address<TAccountTakerBroker>;
    makerBroker?: Address<TAccountMakerBroker>;
    marginAccount?: Address<TAccountMarginAccount>;
    whitelist: Address<TAccountWhitelist>;
    cosigner?: TransactionSigner<TAccountCosigner>;
    rentDestination?: Address<TAccountRentDestination>;
    nonce?: TakeBidCompressedMetaHashInstructionDataArgs['nonce'];
    index: TakeBidCompressedMetaHashInstructionDataArgs['index'];
    root: TakeBidCompressedMetaHashInstructionDataArgs['root'];
    metaHash: TakeBidCompressedMetaHashInstructionDataArgs['metaHash'];
    creatorShares: TakeBidCompressedMetaHashInstructionDataArgs['creatorShares'];
    creatorVerified: TakeBidCompressedMetaHashInstructionDataArgs['creatorVerified'];
    sellerFeeBasisPoints: TakeBidCompressedMetaHashInstructionDataArgs['sellerFeeBasisPoints'];
    minAmount: TakeBidCompressedMetaHashInstructionDataArgs['minAmount'];
    optionalRoyaltyPct?: TakeBidCompressedMetaHashInstructionDataArgs['optionalRoyaltyPct'];
    creators?: TakeBidCompressedMetaHashInstructionExtraArgs['creators'];
    proof?: TakeBidCompressedMetaHashInstructionExtraArgs['proof'];
    canopyDepth?: TakeBidCompressedMetaHashInstructionExtraArgs['canopyDepth'];
};
export declare function getTakeBidCompressedMetaHashInstruction<TAccountFeeVault extends string, TAccountTreeAuthority extends string, TAccountSeller extends string, TAccountDelegate extends string, TAccountMerkleTree extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountSystemProgram extends string, TAccountBubblegumProgram extends string, TAccountMarketplaceProgram extends string, TAccountTensorswapProgram extends string, TAccountBidState extends string, TAccountOwner extends string, TAccountTakerBroker extends string, TAccountMakerBroker extends string, TAccountMarginAccount extends string, TAccountWhitelist extends string, TAccountCosigner extends string, TAccountRentDestination extends string>(input: TakeBidCompressedMetaHashInput<TAccountFeeVault, TAccountTreeAuthority, TAccountSeller, TAccountDelegate, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountTensorswapProgram, TAccountBidState, TAccountOwner, TAccountTakerBroker, TAccountMakerBroker, TAccountMarginAccount, TAccountWhitelist, TAccountCosigner, TAccountRentDestination>): TakeBidCompressedMetaHashInstruction<typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountFeeVault, TAccountTreeAuthority, (typeof input)['seller'] extends TransactionSigner<TAccountSeller> ? WritableSignerAccount<TAccountSeller> & IAccountSignerMeta<TAccountSeller> : TAccountSeller, (typeof input)['delegate'] extends TransactionSigner<TAccountDelegate> ? ReadonlySignerAccount<TAccountDelegate> & IAccountSignerMeta<TAccountDelegate> : TAccountDelegate, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountTensorswapProgram, TAccountBidState, TAccountOwner, TAccountTakerBroker, TAccountMakerBroker, TAccountMarginAccount, TAccountWhitelist, TAccountCosigner, TAccountRentDestination>;
export type ParsedTakeBidCompressedMetaHashInstruction<TProgram extends string = typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        feeVault: TAccountMetas[0];
        treeAuthority: TAccountMetas[1];
        seller: TAccountMetas[2];
        delegate: TAccountMetas[3];
        merkleTree: TAccountMetas[4];
        logWrapper: TAccountMetas[5];
        compressionProgram: TAccountMetas[6];
        systemProgram: TAccountMetas[7];
        bubblegumProgram: TAccountMetas[8];
        marketplaceProgram: TAccountMetas[9];
        tensorswapProgram: TAccountMetas[10];
        bidState: TAccountMetas[11];
        owner: TAccountMetas[12];
        takerBroker?: TAccountMetas[13] | undefined;
        makerBroker?: TAccountMetas[14] | undefined;
        marginAccount: TAccountMetas[15];
        whitelist: TAccountMetas[16];
        cosigner?: TAccountMetas[17] | undefined;
        rentDestination: TAccountMetas[18];
    };
    data: TakeBidCompressedMetaHashInstructionData;
};
export declare function parseTakeBidCompressedMetaHashInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedTakeBidCompressedMetaHashInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=takeBidCompressedMetaHash.d.ts.map